#!/usr/bin/haserl
<?
. /usr/lib/webif/webif.sh

if ! empty "$FORM_umount"; then
	if ! empty "$FORM_mountdev"; then
		err_umount=$(umount $FORM_mountdev 2>&1)
		! equal "$?" "0" && {
			ERROR="Error in $err_umount"
		}
	fi
fi

header "Status" "USB" "USB Devices"

?>
	<table width="100%" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td class="listtopic">All connected devices</td>
        </tr>
        <tr>
          <td>
            <table width="100%" border="0" cellspacing="0" cellpadding="0">
<?

[ -f /proc/bus/usb/devices ] && grep -e "^[TDPS]:" /proc/bus/usb/devices | sed 's/[[:space:]]*=[[:space:]]*/=/g' | sed 's/[[:space:]]\([^ |=]*\)=/|\1=/g' | sed 's/^/|/' | awk '
	BEGIN {
		i=0; RS="|"; FS="=";
		print "              <tr>"
		print "                <td class=\"listhdrlr\">Bus</td>"
		print "                <td class=\"listhdrr\">Device</td>"
		print "                <td class=\"listhdrr\">Product</td>"
		print "                <td class=\"listhdrr\">Manufacturer</td>"
		print "                <td class=\"listhdrr\">VendorID:ProdID</td>"
		print "                <td class=\"listhdrr\">USB version</td>"
		print "                <td class=\"listhdrr\">Speed</td>"
		print "              </tr>"
	}
	$1 ~ /^T: / { i++; }
	$1 ~ /^Bus/ { bus[i]=$2; }
	$1 ~ /^Dev#/ { device[i]=$2; }
	$1 ~ /^Ver/ { usbversion[i]=$2; }
	$1 ~ /^Vendor/ { vendorID[i]=$2; }
	$1 ~ /^ProdID/ { productID[i]=$2; }
	$1 ~ /^Manufacturer/ { manufacturer[i]=$2; }
	$1 ~ /^Product/ { product[i]=$2; }
	$1 ~ /^Spd/ { speed[i]=$2; gsub(/[[:space:]]*$/, "", speed[i]); }
	END {
		for ( j=1; j<=i; ++j ) {
			vpID=vendorID[j]":"productID[j];
			if ( length(product[j])<1 && vpID != "0000:0000" ) {
				"/usr/sbin/lsusb -d " vpID " | sed \"s/^.*" vpID " //\"" | getline product[j];
			}
			if ( length(manufacturer[j])<1 && productID[j]!="0000" ) {
				pid=vendorID[j];
				"[ -f /usr/share/misc/usb.ids ] && grep -e \"^" pid "\" /usr/share/misc/usb.ids | sed \"s/^" pid " *//\"" | getline manufacturer[j];
			}
			if ( vpID != "0000:0000" ) {
				print "              <tr>"
				print "                <td class=\"listlr\">" bus[j] "</td>"
				print "                <td class=\"listr\">" device[j] "</td>"
				print "                <td class=\"listr\">" product[j] "</td>"
				print "                <td class=\"listr\">" manufacturer[j] "</td>"
				print "                <td class=\"listr\">" vpID "</td>"
				print "                <td class=\"listr\">" usbversion[j] "</td>"
				print "                <td class=\"listr\">" speed[j] "</td>"
				print "              </tr>"
			}
		}
	}
'

?>
            </table>
          </td>
        </tr>
<?

mounted_devices="$(cat /proc/mounts | grep -e "^/dev/sd[a-p]\{0,2\}" -e "^/dev/scsi/.*")"
! equal "$mounted_devices" "" && {
	cat << EOF
		<tr>
          <td class="list" height="12">&nbsp;</td>
        </tr>
        <tr>
          <td class="listtopic">Mounted USB Drives</td>
        </tr>
        <tr>
          <td>
            <table width="100%" border="0" cellspacing="0" cellpadding="0">
EOF
	echo "$mounted_devices" | awk -v url="$SCRIPT_NAME" '
	BEGIN {
		print "              <tr>"
		print "                <td class=\"listhdrlr\">Device Path</td>"
		print "                <td class=\"listhdrr\">Mount Point</td>"
		print "                <td class=\"listhdrr\">File System</td>"
		print "                <td class=\"listhdrr\">Read/Write</td>"
		print "                <td class=\"listhdrr\">Action</td>"
		print "              </tr>"
	}
	{
		print "              <tr>"
		print "                <td class=\"listlr\">" $1 "</td>"
		print "                <td class=\"listr\">" $2 "</td>"
		print "                <td class=\"listr\">" $3 "</td>"
		$4 = "," $4 ","
		if ($4 ~ /,ro,/)
			print "                <td class=\"listr\">Read only</td>"
		else if ($4 ~ /,rw,/)
			print "                <td class=\"listr\">Read/Write</td>"
		else
			print "                <td class=\"listr\">&nbsp;</td>"
		print "                <td class=\"listr\"><form method=\"post\" action=\"" url "\"><input type=\"submit\" value=\"Unmount\" name=\"umount\" /><input type=\"hidden\" value=\"" $1 "\" name=\"mountdev\" /></form></td>"
		print "              </tr>"
	}'
	cat << EOF
            </table>
          </td>
        </tr>
EOF
}

?>

</table>

<? footer ?>
<!--
##WEBIF:name:Status:400:USB
-->
